'''
Created on May 22, 2016

@author: tibi
'''
from model import Word

def getGender(word):
    
    if word.isPronoun() and (word.pronounGetPerson() == '1' or word.pronounGetPerson() == '2'):
        return 'n'

    return word.getGender()

def genderMatch(word1, word2):
  
    g1 = getGender(word1)
    g2 = getGender(word2)
    
    if g1 == g2:
        return 2

    if g1 == 'n' or g2 == 'n':
        return 1
     
    return 0

def isPrepositional(chunk):
    
    for word in chunk:
        
        if word.isPreposition():
            return True
        
    return False

def countInText(noun, text):
    
    c = 0
    for word in text:
        if word.text == noun.text:
            c += 1
    
    return c

def anaphora(text, chunks):
    
    nounPhrases = []
    
    for word in text:
        
        if word.isNoun():
            print("[n]", word)
            nounPhrases.append((word, (word.sentenceIndex, word.chunk)))
            
        else:
            print(word)
            
        if word.isPronoun():
            
            candidates = []
            
            for noun, chunkIndex in nounPhrases[:-30:-1]:
                
                # If gender and number match
                if genderMatch(word, noun) > 0 and word.getNumber() == noun.getNumber():
                    
                    npInd = genderMatch(word, noun)
                                        
                    # definiteness
                    if not noun.nounIsDefinite():
                        npInd -= 1
                    
                    # non-prepositional noun phrase
                    chunk = chunks[chunkIndex]
                    if (isPrepositional(chunk)):
                        npInd -= 1
                    
                    # first in sentence
                    if noun.sentenceIndex == 1:
                        npInd += 1
                        
                    # indicating verbs
                    # todo...
                    
                    # lexical reiteration
                    c = countInText(noun, text)
                    if c == 2:
                        npInd += 1
                    if c > 2:
                        npInd += 2
                        
                    # noun is representing term
                    # how?
                    
                    # identical collocation pattern to the pronoun
                    # ???
                    
                    # immediate reference, resolving 'it'
                    # applicable?
                    
                    # referential distance
                    dist = word.sentenceIndex - noun.sentenceIndex
                    if dist == 0:
                        npInd += 2
                    elif dist == 1:
                        npInd += 1
                    
                    candidates.append((noun, npInd))
                    print("...> Candidate: {0} npInd = {1}".format(noun, npInd))
            
            
            if len(candidates) > 0:
                
                pickedWord, pickedInd = candidates[0]
                for word, npInd in candidates:
                    if npInd > pickedInd:
                        pickedInd = npInd
                        pickedWord = word
                
                print(".>>> Picked: {0}".format(pickedWord))
