'''
Created on May 22, 2016

@author: tibi
'''

class Word:

    text = ""
    lemma = ""
    ana = ""
    chunk = ""
    
    sentenceIndex = 0
    wordIndex = 0
    
    def __init__(self, text, lemma, ana, chunk, sentenceIndex, wordIndex):
        self.text = text
        self.lemma = lemma
        self.ana = ana
        self.chunk = chunk
        self.sentenceIndex = sentenceIndex
        self.wordIndex = wordIndex
        
    def __str__(self):
        return "{0} (lemma {1}, ana {2}, chunk {3})".format(self.text, self.lemma, self.ana, self.chunk)
        
    def isNoun(self):
        return self.ana[0] == "N"
    
    def nounIsCommon(self):
        return self.isNoun() and self.ana[1] == "c"

    def nounIsProper(self):
        return self.isNoun() and self.ana[1] == "p"
    
    def nounGetCase(self):
        
        if self.isNoun():
            return self.ana[4]
        
        return None
    
    'Este articulat?'
    def nounIsDefinite(self):
        if self.isNoun():
            if (self.nounIsProper()):
                return True
            
            if len(self.ana) > 5:
                return self.ana[5]
        
        return "n"
    
    def pronounGetPerson(self):
        if self.isPronoun():
            return self.ana[2]
    
    def getGender(self):
        if self.isNoun():
            if (len(self.ana) >= 3):
                return self.ana[2]
            return 'n'
        
        if self.isPronoun():
            return self.ana[3]
            
        return None
    
    def getNumber(self):
        if self.isNoun():
            if self.nounIsProper():
                return 's'
            else:
                return self.ana[3]
        if self.isPronoun():
            return self.ana[4]
        
        return None
    
    def isPronoun(self):
        return self.ana[0] == "P"
    
    def isVerb(self):
        return self.ana[0] == "V"
    
    def isPreposition(self):
        return self.ana[0] == "S" and self.ana[1] == "p"